// Rmy LUCAS - Septembre 2001
//
// electroremy@aol.com
//
// Programme cadre pour commander la super interface
// ou tout autre montage connect sur le port parallle.
//
// http://www.ifrance.com/electroremy
//
// Des explications dtailles figurent  la fin du fichier.


#include <stdio.h>
#include <dos.h>
#include <conio.h>

// pow2(i) est 6 fois plus rapide que la fonction pow(2,i) de math.h
// Aussi, on peut compiler sans math.h et sans les nombres flottants.
unsigned char pow2(unsigned char num) {
	switch (num) {
		case 0:	return 1; break;
		case 1: return 2; break;
		case 2: return 4; break;
		case 3: return 8; break;
		case 4: return 16; break;
		case 5: return 32; break;
		case 6: return 64; break;
		case 7: return 128; break;
	};
}

class portpar {
private:
	int adr_data;   // sorties donnees
	int adr_statut; // entrees
	int adr_ctrl;   // sorties ctrl
	int adr_nport;  // numros du port

	// Ces variables contiennent l'image du port parallle :
	unsigned char mirroirc; // Registre de CONTROLE (sorties)
	unsigned char mirroird; // Registre de DONNEES (sorties)
	unsigned char mirroire; // Registre d'ETAT (entre)
public:
	portpar (void) {
		adr_nport=2;
		adr_data=0x378;   // sorties donnees
		adr_statut=0x379; // entrees
		adr_ctrl=0x37A;   // sorties
	};

	void affport (void) {
		printf("Port parallle utilis :\n");
		printf("    N ");
		printf("%d",adr_nport);
		printf("\n    Adresse (donnes) : &H");
		printf("%X",adr_data);
		printf("\n\n");
	};

	void setport(int num) {
		switch (num) {
		case 1:
			adr_nport=1;
			adr_data=0x3BC;   // sorties donnees
			adr_statut=0x3BD; // entrees
			adr_ctrl=0x3BE;   // sorties
			break;
  		case 2:
			adr_nport=2;
			adr_data=0x378;   // sorties donnees
			adr_statut=0x379; // entrees
			adr_ctrl=0x37A;   // sorties
			break;
  		case 3:
			adr_nport=3;
			adr_data=0x278;   // sorties donnees
			adr_statut=0x279; // entrees
			adr_ctrl=0x27A;   // sorties
			break;
  		};
	};

	void ecrit(void){
		outportb(adr_ctrl,mirroirc);
		outportb(adr_data,mirroird);
	};

	void lit(void){
		mirroire=inportb(adr_statut);
	};

	int testbit(int bit) {
		if ((bit<3)||(bit>7)) {
			printf("ERREUR dans la fonction INT TESTBIT(INT)\n");
			printf("Le paramtre doit tre un entier compris entre 3 et 7\n");
		} else {
			return ((mirroire&pow2(bit))!=0);
		};
	};

	void raz(void){
		mirroirc=11;
		mirroird=0;
		ecrit();
	};

	void setbitdata(int bit){
		if ((bit<0)||(bit>7)) {
			printf("ERREUR dans la procdure SETBITDATA(int)\n");
			printf("Le paramtre doit tre un entier compris entre 0 et 7\n");
		} else {
			mirroird=mirroird|pow2(bit);
		};
	};

	void resetbitdata(int bit){
		if ((bit<0)||(bit>7)) {
			printf("ERREUR dans la procdure RESETBITDATA(int)\n");
			printf("Le paramtre doit tre un entier compris entre 0 et 7\n");
		} else {
			mirroird=mirroird&(255-pow2(bit));
		};
	};

	void putdata(unsigned char data){
		mirroird=data;
	};

	void setbitctrl(int bit){
		if ((bit<0)||(bit>3)) {
			printf("ERREUR dans la procdure SETBITCTRL(int)\n");
			printf("Le paramtre doit tre un entier compris entre 0 et 3\n");
		} else {
			mirroirc=mirroirc|pow2(bit);
		};
	};

	void resetbitctrl(int bit){
		if ((bit<0)||(bit>3)) {
			printf("ERREUR dans la procdure RESETBITCTRL(int)\n");
			printf("Le paramtre doit tre un entier compris entre 0 et 3\n");
		} else {
			mirroirc=mirroirc&(255-pow2(bit));
		};
	};
};

unsigned char tapertouche(void) {
	do {
	} while(!kbhit());
	return getch();
};

int main(){
	portpar inter2;

// RELGEZ ICI LE NUMEROS DU PORT PARALLELE UTILISE --------------------------

	inter2.setport(2);  // 2 est le reglage le plus courant.

// --------------------------------------------------------------------------

	inter2.raz();
	inter2.lit();

	clrscr();

// DECLAREZ LES EVENTUELLES VARIABLES DE VOTRE PROGRAMME ICI : --------------

	unsigned char touche;

// DEBUT DE VOTRE PROGRAMME - A vous de jouer :-) ---------------------------

	// VOICI UN EXEMPLE (inspirez vous en pour crer vos programmes):

	inter2.affport();      // On affiche des infos sur le port utilis

	inter2.setbitdata(0);  // On met le bit0 du tampon de donnes  1
	inter2.ecrit();        // On recopie les tampons vers le port

	printf("J'attends 3 secondes\n\n");

	delay(3000);  // On attends 3 secondes

	inter2.setbitdata(5);    // On met le bit5 du tampon de donnes  1
	inter2.resetbitdata(0);    // On met le bit0 du tampon de donnes  0
	inter2.setbitdata(7);    // On met le bit7 du tampon de donnes  1
	inter2.ecrit();        // On recopie les tampons vers le port


	printf("J'attends un niveau 1 sur ERROR\n\n");

	do {
		inter2.lit();           // On recopie le registre d'tat dans
					// le tampon d'tat
	} while (!inter2.testbit(3)==1);// On arrte de boucler quand le bit3
					// du tampon d'tat est  1


	inter2.resetbitctrl(0);  // On met le bit0 du tampon de contrle  0
	inter2.setbitctrl(2);    // On met le bit2 du tampon de contrle  1
	inter2.ecrit();       // On recopie les tampons vers le port


	printf("J'attends un niveau 0 sur BUSY\n\n");

	do {
		inter2.lit();
	} while (!inter2.testbit(7)==0);


	inter2.putdata(155); // On affecte la valeur 155 au tampon de donnes
	inter2.ecrit();      // On recopie les tampons vers le port


	printf("J'attends un niveau 0 sur BUSY et un niveau 1 sur ACKNOLEDGE\n\n");

	do {
		inter2.lit();
	} while (!((inter2.testbit(7)==0)&&(inter2.testbit(6)==1)));


	inter2.setbitctrl(0);  // On met le bit0 du tampon de contrle  1
	inter2.resetbitctrl(2);  // On met le bit2 du tampon de contrle  0
	inter2.putdata(126); // On affecte la valeur 126 au tampon de donnes
	inter2.ecrit();       // On recopie les tampons vers le port


	printf("J'attends un niveau 1 sur ERROR ou un niveau 1 sur SELECT\n\n");

	do {
		inter2.lit();
	} while (!((inter2.testbit(3)==1)||(inter2.testbit(4)==1)));


	inter2.raz(); // On met toutes les broches de sorties du port  0V

	printf("J'attends que vous tapiez une touche\n");
	touche=tapertouche();

	// FIN DE L'EXEMPLE

// FIN DE VOTRE PROGRAMME ---------------------------------------------------

	inter2.raz();
	return 0;
}

/*
       ******************** QUELQUES EXPLICATIONS ********************


	Faites une nouvelle copie de ce programme cadre  chaque fois que vous
crivez un nouveau programme utilisant le port parallle.




	La seule partie de ce fichier o vous pouvez taper votre code est
celle dlimit par les lignes :

// DEBUT DE VOTRE PROGRAMME - A vous de jouer :-) ---------------------------

// FIN DE VOTRE PROGRAMME ---------------------------------------------------

	Selon les instructions que vous utilisez, vous aurez peut-tre 
modifier le dbut du programme inclure d'autres "librairies".
	Si vous voulez dfinir vos propres classes, procdures ou fonctions,
vous devrez les saisir avant la fonction "int main(void)".




	Un port parallle est du point de vue logiciel constitu de 3 octets,
appells "registres". Il y a un registre de contrle (sorties), un registre
de donnes (sorties) et un registre d'tat (entres).
	Voici a quoi correspondent les bits de chaque registre :

Registre de contrle :	BIT0 /STROBE
			BIT1 /AUTOFEED
			BIT2  INITIALIZE
			BIT3 /SELECT INPUT
			BIT4 - Aucune broche ne corresponds  ce bit -
			BIT5 - Aucune broche ne corresponds  ce bit -
			BIT6 - Aucune broche ne corresponds  ce bit -
			BIT7 - Aucune broche ne corresponds  ce bit -

Registre de donnes :	BIT0 D0
			BIT1 D1
			BIT2 D2
			BIT3 D3
			BIT4 D4
			BIT5 D5
			BIT6 D6
			BIT7 D7

Registre d'tat :	BIT0  - Aucune broche ne corresponds  ce bit -
			BIT1  - Aucune broche ne corresponds  ce bit -
			BIT2  - Aucune broche ne corresponds  ce bit -
			BIT3  ERROR
			BIT4  SELECT
			BIT5  PAPER OUT
			BIT6  ACKNOWLEDGE
			BIT7 /BUSY

	Le caractre "/" indique que le bit est invers. En d'autre terme, un
tel bit mis  "0" par le logiciel mettera la broche correspondante du port 
"+5V", et si ce bit est mis  "1" par le logiciel la broche sera mise  "0V".




	Au dbut du programme, une classe "portpar" est dfinie. Puis une
variable "inter2" de type "portpar" est dclare. "inter2" est donc un objet
de type "portpar".

	La classe "portpar" possde plusieurs mthodes (c'est  dire des
procdures et des fonctions) dont l'utilit est dcrite ci-dessous :

PROCEDURE setport(int)

		Permet de choisir le numros du port parallle utilis. Trois
	valeurs sont possibles comme paramtre : 1, 2 ou 3.

        	Dans la grande majorit des cas, le port LPT1 d'un P.C.
	corresponds au numros 2.

		Un P.C. peut comporter jusqu'a trois ports parallles, mais
	comme nous venons de le voir pour LPT1, le numros du port (2) n'a
	aucun rapport avec le nom donn au port par votre systme
	d'exploitation (LPT1).

PROCEDURE affport ()

		Cette procdure affiche  l'cran le numros du port choisi
	ainsi que l'adresse de son registre de donnes.

		L'utilitaire MSD.EXE de MS-DOS permet de connatre l'adresse
	du registre de donne de votre port parallle. Vous pouvez ainsi
	faire le lien entre l'adresse donne par MSD et le numros de port
	requis par la procdure setport():

		Numros de port		Adresse
			1		 &H3BC
			2		 &H378
			3		 &H278

PROCEDURE ecrit()

		Cette procdure recopie le tampon de contrle vers le
	registre de contrle du port parallle et le tampon de donnes vers
	le registre de donnes.

PROCEDURE lit()

		Cette procdure recopie le registre d'tat du port parallle
	vers le tampon d'tat.

FONCTION int testbit(int)

		Cette fonction retourne la valeur (0 ou 1) du bit du tampon
	d'tat dont le rang corresponds au paramtre pass  la fonction.

		Le paramtre de la fonction doit tre un entier compris entre
	3 et 7.

PROCEDURE raz()

		Cette procdure affecte les valeurs suivantes aux deux
	tampons de sortie :

		tampon de contrle = 11
		tampon de donnes = 0

		et elle recopie ces valeurs dans les registres correspondant
	du port parallle.

		De cette manire, toutes les broches de sorties du port sont
	mises  la masse (0V).

PROCEDURE setbitdata(int)

		Cette procdure met  "1" le bit du tampon de donnes dont
	le rang corresponds au paramtre pass  la procdure.

		Ce paramtre doit tre un entier compris entre 0 et 7.

PROCEDURE resetbitdata(int)

		Cette procdure met  "0" le bit du tampon de donnes dont
	le rang corresponds au paramtre pass  la procdure.

		Ce paramtre doit tre un entier compris entre 0 et 7.

PROCEDURE putdata(unsigned char)

		Cette procdure affecte directement l'octet pass en paramtre
	au tampon de donnes.

		Le paramtre est de type "unsigned char", c'est  dire un
	entier compris entre 0 et 255.

PROCEDURE setbitctrl(int)

		Cette procdure met  "1" le bit du tampon de contrle dont
	le rang corresponds au paramtre pass  la procdure.

		Ce paramtre doit tre un entier compris entre 0 et 3.

PROCEDURE resetbitctrl(int)

		Cette procdure met  "0" le bit du tampon de contrle dont
	le rang corresponds au paramtre pass  la procdure.

		Ce paramtre doit tre un entier compris entre 0 et 3.
*/




